IMPLEMENTATION MODULE Lista;

FROM Cadenas IMPORT Comparar, Copiar, TCadena;
FROM Storage IMPORT Available, ALLOCATE, DEALLOCATE;

TYPE
	TVuelta = POINTER TO TCiclista;
	
	TCiclista = RECORD
			nombre: TCadena;
			dorsal: CARDINAL;
			horas: CARDINAL;
			minutos: CARDINAL;
			segundos: CARDINAL;
			siguiente: TVuelta;
		END;
		
PROCEDURE CrearLista( VAR list: TVuelta);
BEGIN
	list := NIL;
END CrearLista;

PROCEDURE DestruirLista( VAR list: TVuelta );
VAR
	aux: TVuelta;
	
BEGIN
	WHILE (list <> NIL) DO
		aux := list;
		list := list^.siguiente;
		DISPOSE(aux);
	END;
END DestruirLista;

PROCEDURE InsertarenLista( VAR list: TVuelta; nom: ARRAY OF CHAR; dor, hh, mm, ss: CARDINAL; VAR error: BOOLEAN);
VAR
	aux: TVuelta;
	
BEGIN
	error := FALSE;
	IF Available(SIZE( TCiclista )) THEN
		NEW(aux);
		Copiar(aux^.nombre,nom);
		aux^.dorsal := dor;
		aux^.horas := hh;
		aux^.minutos := mm;
		aux^.segundos := ss;	
		aux^.siguiente := list;
		list := aux;
	ELSE
		error := FALSE;
	END;
END InsertarenLista;

PROCEDURE BorrarenLista(VAR list: TVuelta; dor: CARDINAL; VAR error: BOOLEAN);
VAR
	aux, ant: TVuelta;
    encontrado: BOOLEAN;

BEGIN
	encontrado := FALSE;
	error := FALSE;
	IF list <> NIL THEN
		aux := list;
		IF aux^.dorsal = dor THEN
			list := list^.siguiente;
			DISPOSE(aux);
		ELSE
			WHILE (aux<> NIL) AND (NOT(encontrado)) DO
				IF aux^.dorsal = dor THEN
					encontrado := TRUE;
				ELSE
					ant := aux;
					aux := aux^.siguiente;
				END;
			END;
			IF encontrado THEN
				ant^.siguiente := aux^.siguiente;
				DISPOSE(aux);
			ELSE
				error := TRUE;
			END;
		END;
	ELSE
		error := TRUE;
	END;
END BorrarenLista;

PROCEDURE IterarLista(list: TVuelta; pos: CARDINAL; VAR nom: ARRAY OF CHAR; VAR dor: CARDINAL; VAR hh: CARDINAL; VAR mm: CARDINAL; VAR ss: CARDINAL; VAR error: BOOLEAN);
VAR
	aux: TVuelta;
	i: CARDINAL;
	
BEGIN
	error := FALSE;
	i := 1;
	aux := list;
	WHILE (i < pos ) AND (aux <> NIL) DO
		aux := aux^.siguiente;
		INC(i);
	END;
	IF aux = NIL THEN
		error := TRUE;
	ELSE
		Copiar(nom, aux^.nombre);
		dor := aux^.dorsal;
		hh := aux^.horas;
		mm := aux^.minutos;
		ss := aux^.segundos;
	END;
END IterarLista;

PROCEDURE Longitud(list: TVuelta): CARDINAL;
VAR
	aux: TVuelta;
	long: CARDINAL;
	
BEGIN
	long := 0;
	IF list <> NIL THEN
		long := 1;
		aux := list;
		WHILE aux <> NIL DO
			aux := aux^.siguiente;
			INC(long);
		END;
	END;
	RETURN(long);
END Longitud;

END Lista.
