(* ---------------------------------------- *)
(* 											*)
(*		Victor Manuel Jimnez Bascn		*)
(*				1B  Sistemas				*)
(*											*)
(* ---------------------------------------- *)

MODULE Vuelta;

FROM Cadenas IMPORT Comparar, Copiar, TCadena;
FROM Lista IMPORT CrearLista, DestruirLista, InsertarenLista, BorrarenLista, IterarLista, Longitud, TVuelta;
FROM Window IMPORT Clear;
IMPORT IO;
IMPORT FIO;


TYPE
	TEquipo = (IGest, ISist, ISup, TelecoSup, TelecoTec);
	
	TConjunto = SET OF TEquipo;	

	TArrayEquipos = ARRAY TEquipo OF TVuelta;
	
VAR
	vcampus: TArrayEquipos;
	salir: BOOLEAN;
	opcion: CHAR;
	i: TEquipo;

	PROCEDURE Menu(): CHAR;
	VAR
		opcion: CHAR;
		
    BEGIN
    	Clear;
		IO.WrLn;
		IO.WrStr("Vuelta ciclista al campus"); IO.WrLn;
		IO.WrStr("-------------------------"); IO.WrLn;
	    IO.WrLn;
        IO.WrStr("A.- Volcar desde fichero."); IO.WrLn;
        IO.WrStr("B.- Visualizar datos."); IO.WrLn;
        IO.WrStr("C.- Actualizacin de etapa."); IO.WrLn;
        IO.WrStr("D.- Baja."); IO.WrLn;
        IO.WrStr("E.- Volcar a fichero."); IO.WrLn;
        IO.WrStr("F.- Salir."); IO.WrLn;
        IO.WrLn;
        IO.WrStr("Elige una opcin: ");
        IO.RdLn;
        opcion := CAP(IO.RdChar());
        RETURN(opcion)
    END Menu;

	PROCEDURE EquipoCad(cad:TCadena): TEquipo;
	VAR
		eq: TEquipo;
		
	BEGIN
		IF Comparar(cad, "IGest") THEN
			eq := IGest;
		ELSIF Comparar(cad, "ISist") THEN
			eq := ISist;
		ELSIF Comparar(cad, "ISup") THEN
			eq := ISup;
		ELSIF Comparar(cad, "TelecoSup") THEN
			eq := TelecoSup;
		ELSIF Comparar(cad, "TelecoTec") THEN
			eq := TelecoTec;
		END;
		RETURN(eq)
	END EquipoCad;

	PROCEDURE CadEquipo( eq: TEquipo ): TCadena;
	VAR
		cad: TCadena;
			
	BEGIN
		IF eq = IGest THEN
			Copiar(cad, "IGest");
		ELSIF eq = ISist THEN
			Copiar(cad, "ISist");
		ELSIF eq = ISup THEN
			Copiar(cad, "ISup");
		ELSIF eq = TelecoSup THEN
			Copiar(cad, "TelecoSup");
		ELSIF eq = TelecoTec THEN
			Copiar(cad, "TelecoTec");
		END;
		RETURN(cad);
	END CadEquipo;			

	PROCEDURE OpcionA( VAR vue: TArrayEquipos );
	VAR
		nomfich: ARRAY [0..11] OF CHAR;
		fich: FIO.File;
		error: BOOLEAN;
		i: TEquipo;
		nom: TCadena;
		equi: TCadena;
		eq: TEquipo;
		dor, hh,mm,ss: CARDINAL;
		car: CHAR;
		nada: TCadena;
		conj: TConjunto;		
		
	BEGIN
		Clear();	
		error := FALSE;
		conj := TConjunto{IGest, ISist, ISup, TelecoSup, TelecoTec};
		IO.WrLn;
		IO.WrStr("Opcin A."); IO.WrLn;
		IO.WrLn;
		IO.WrLn;
		IO.WrStr("Nombre del fichero: ");
		IO.RdLn;
		IO.RdStr(nomfich);
		IF FIO.Exists(nomfich) THEN
			FOR i := IGest TO TelecoTec DO
				DestruirLista(vue[i]);
				CrearLista(vue[i]);
			END;
			fich := FIO.Open(nomfich);
			WHILE (NOT FIO.EOF) AND (NOT error) DO
				FIO.RdStr(fich, nom);
				FIO.RdStr(fich, equi);
				dor := FIO.RdCard(fich);
				hh := FIO.RdCard(fich);
				mm := FIO.RdCard(fich);
				ss := FIO.RdCard(fich);
				FIO.RdStr(fich, nada);
				eq := EquipoCad(equi);
				IF eq IN conj THEN
					IO.RdLn;
					InsertarenLista(vue[eq], nom, dor, hh, mm, ss, error);
				END;
			END;
			FIO.Close(fich);
		ELSE
			IO.RdLn;
			IO.WrLn;
			IO.WrLn;
			IO.WrStr("El fichero no existe.");
		END;
		IF error THEN
			IO.RdLn;
			IO.WrLn;
			IO.WrLn;
			IO.WrStr("Se ha producido un error.");
			REPEAT UNTIL(IO.KeyPressed());
			IO.RdLn;
		END;
	END OpcionA;
	
	PROCEDURE OpcionB(VAR vue: TArrayEquipos);
	VAR
		nom: TCadena;
		equi: TCadena;
		eq: TEquipo;
		dor: CARDINAL;
		hh: CARDINAL;
		mm: CARDINAL;
		ss: CARDINAL;
		long, i: CARDINAL;
		error: BOOLEAN;
	
	BEGIN
		Clear();
		IO.WrLn;
		IO.WrStr("Visualizacin de la estructura."); IO.WrLn;
		IO.WrLn;
		FOR eq := IGest TO TelecoTec DO
			long := Longitud(vue[eq]);
			equi := CadEquipo(eq);
			FOR i := 1 TO long DO
				IO.RdLn;
				IterarLista(vue[eq], i, nom, dor, hh, mm, ss, error); 	
				IO.WrStr(nom); IO.WrLn;
				IO.WrStr(equi); IO.WrLn;
				IO.WrCard(dor,3); IO.WrLn;
				IO.WrCard(hh,2);
				IO.WrChar("/");
				IO.WrCard(mm,2);
				IO.WrChar("/");
				IO.WrCard(ss,2); IO.WrLn;
				IO.WrLn;
			END;
		END;
		REPEAT UNTIL(IO.KeyPressed());
		IF error THEN
			IO.RdLn;
			IO.WrLn;
			IO.WrLn;
			IO.WrStr("Se ha producido un error.");
			REPEAT UNTIL(IO.KeyPressed());
			IO.RdLn;
		END;
	END OpcionB;
	
    PROCEDURE OpcionC( VAR vue: TArrayEquipos );
    VAR
    	nom: TCadena;
    	hh, mm, ss: CARDINAL;
    	dor, h, m, s: CARDINAL;
    	eq, equip: TEquipo;
    	long, i: CARDINAL;
    	nomb: TCadena;
    	encontrado, error: BOOLEAN;

	BEGIN
		Clear();
		encontrado := FALSE;
		error := FALSE;
		IO.WrLn;
		IO.WrStr("Opcin C.");IO.WrLn;
		IO.WrLn;
		IO.WrStr("Nombre del ciclista: ");
		IO.RdLn;
		IO.RdStr(nom);
		IO.WrLn;
		IO.WrLn;
		IO.WrStr("Tiempo de etapa( formato hh mm ss ): ");
		IO.RdLn;
		hh := IO.RdCard();
		mm := IO.RdCard();
		ss := IO.RdCard();	
		FOR eq := IGest TO TelecoTec DO
			long := Longitud(vue[eq]);
			FOR i := 1 TO long DO
				IF NOT encontrado THEN
					IterarLista(vue[eq], i, nomb, dor, h, m, s, error);
					IF Comparar(nom, nomb) THEN
						equip := eq;
						encontrado := TRUE;
					END;
				END;
			END;
		END;
		IF encontrado THEN
			IO.RdLn;
			BorrarenLista(vue[equip], dor, error);
			hh := ((((ss + s) DIV 60) + mm + m) DIV 60) + hh + h;
			mm := (((ss + s) DIV 60)+ mm + m) MOD 60;
			ss := (ss + s) MOD 60;
			IO.RdLn;
			InsertarenLista( vue[equip], nom, dor, hh, mm, ss, error);
		ELSE
			IO.WrLn;
			IO.WrLn;
			IO.WrStr("No se ha encontrado al ciclista.");
			REPEAT UNTIL(IO.KeyPressed());
			IO.RdLn;
		END;
		IF error THEN
			IO.WrLn;
			IO.WrLn;
			IO.WrStr("Se ha producido un error.");
			REPEAT UNTIL(IO.KeyPressed());
			IO.RdLn;
		END;
	END OpcionC;
	
	PROCEDURE OpcionD(VAR vue: TArrayEquipos);
	VAR
		error: ARRAY TEquipo OF BOOLEAN;
		dor: CARDINAL;
		eq: TEquipo;
	
	BEGIN
		Clear();
		FOR eq := IGest TO TelecoTec DO
			error[eq] := FALSE;
		END;
		IO.WrLn;
		IO.WrStr("Opcin D."); IO.WrLn;
		IO.WrLn;
		IO.RdLn;
		IO.WrStr("Introduzca el dorsal del ciclista a eliminar: ");
		dor := IO.RdCard();
		FOR eq := IGest TO TelecoTec DO
			IO.RdLn;
			BorrarenLista(vue[eq], dor, error[eq]);
		END;
		IF error[IGest] THEN
			IF error[ISist] THEN
				IF error[ISup] THEN
					IF error[TelecoSup] THEN
						IF error[TelecoTec] THEN
							IO.WrLn;
							IO.WrLn;
							IO.WrStr("No se ha encontrado al ciclista.");
							REPEAT UNTIL(IO.KeyPressed());
						END;
					END;
				END;
			END;
		END;
	END OpcionD;
	
	PROCEDURE OpcionE( vue: TArrayEquipos );
	VAR
		seguir, error: BOOLEAN;
		car: CHAR;
		long, i: CARDINAL;
		eq: TEquipo;
		nom, equi: TCadena;
		dor, hh, mm, ss: CARDINAL;
		nomfich: ARRAY [0..11] OF CHAR;
		fich: FIO.File;
		
	BEGIN
		Clear();
		seguir := TRUE;
		IO.WrLn;
		IO.WrStr("Opcin E."); IO.WrLn;
		IO.WrLn;
		IO.WrStr("Nombre del fichero: ");
		IO.RdLn;
		IO.RdStr(nomfich);
		IF FIO.Exists(nomfich) THEN
			IO.WrLn;
			IO.WrLn;
			IO.WrStr("El fichero ya existe,"); IO.WrLn;
			IO.WrStr("desea actualizar el fichero? (S/N) ");
			IO.RdLn;
			car := CAP(IO.RdChar());
			IF car <> "S" THEN
				seguir := FALSE;
			END;
		END;
		IF seguir THEN
			fich := FIO.Create(nomfich);
			FOR eq := IGest TO TelecoTec DO
				long := Longitud(vue[eq]);
				FOR i := 1 TO long DO
					IO.RdLn;
					IterarLista(vue[eq], i, nom, dor, hh, mm, ss, error);
					equi := CadEquipo( eq );
					FIO.WrStr(fich, nom);
					FIO.WrLn(fich);
					FIO.WrStr(fich, equi);
					FIO.WrLn(fich);
					FIO.WrCard(fich, dor, 3);
					FIO.WrLn(fich);
					FIO.WrCard(fich, hh, 3);
					FIO.WrChar(fich, " ");
					FIO.WrCard(fich, mm, 2);
					FIO.WrChar(fich, " ");
					FIO.WrCard(fich, ss, 2);
					FIO.WrLn(fich);
				END;
			END;	
			FIO.Close(fich);
		END;
	END OpcionE;
	
	PROCEDURE OpcionF(VAR salir: BOOLEAN);
	VAR
		car: CHAR;
		
	BEGIN
		salir := FALSE;
		IO.RdLn;
		IO.WrLn;
		IO.WrLn;
		IO.WrStr("Desea salir? (S/N): ");
		car := CAP(IO.RdChar());
		IF car = "S" THEN
			salir := TRUE;
		END;
	END OpcionF;
		
BEGIN
	salir := FALSE;
	FOR i := IGest TO TelecoTec DO
		CrearLista(vcampus[i]);
	END;
	REPEAT
		opcion := Menu();
		CASE opcion OF
			"A": OpcionA(vcampus)|
			"B": OpcionB(vcampus)|
			"C": OpcionC(vcampus)|
			"D": OpcionD(vcampus)|
			"E": OpcionE(vcampus)|
			"F": OpcionF(salir)|
		ELSE
			IO.WrLn;
			IO.WrLn;
			IO.WrStr("Esta opcin no existe.");
			REPEAT UNTIL(IO.KeyPressed());
			IO.RdLn;
		END;
	UNTIL salir;
	FOR i := IGest TO TelecoTec DO
		DestruirLista(vcampus[i]);
	END;
END Vuelta.